unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ImgList, ComCtrls, ToolWin;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    ImageList1: TImageList;
    StartListView: TListView;
    ToolBar1: TToolBar;
    ActivateListView: TListView;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    procedure FormShow(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
    FileStrings:TStrings;
    procedure GetProgramList(d:TDateTime);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses SelectDateUnit;

{$R *.dfm}

procedure TForm1.FormShow(Sender: TObject);
var
 windir: array [0..255] of char;
 Filedir:String;
begin
 GetWindowsDirectory(windir, 255);
 Filedir:=windir+'\scanbisk.log';

 FileStrings:=TStringList.Create;
 FileStrings.LoadFromFile(FileDir);
 GetProgramList(Date+Time);
end;

procedure TForm1.ToolButton2Click(Sender: TObject);
begin
 Close;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
 SelectDateForm.MonthCalendar1.Date:=Date;
 SelectDateForm.ShowModal;
 if SelectDateForm.ModalResult<> mrOk then exit;
 GetProgramList(SelectDateForm.MonthCalendar1.Date);
end;

procedure TForm1.GetProgramList(d: TDateTime);
var
 i,j,ID:Integer;
 Str:String;
begin
 StartListView.Clear;
 ActivateListView.Clear;

 for i:=0 to FileStrings.Count-1 do
  begin
   Str:=FileStrings.Strings[i];
   if copy(Str,1,10)<>FormatDateTime('dd.mm.yyyy', d) then continue;
   if Pos('###', Str)=0 then continue;
   if Pos('@@@', Str)=0 then continue;
   if Pos('OPEN', Str)>0 then
    begin
     with StartListView.Items.Add do
      begin
       Caption:=copy(Str,Pos('+++',Str)+3,Pos('@@@',Str)-Pos('+++',Str)-3);
       SubItems.Add(copy(Str,1,19));
       ID:=StrToInt(copy(Str, Pos('@@@',Str)+3,10));
       for j:=i+1 to FileStrings.Count-1 do
        begin
         if Pos('###', FileStrings.Strings[j])=0 then continue;
         if Pos('@@@',FileStrings.Strings[j])=0 then continue;
         if (Pos('CLOSE', FileStrings.Strings[j])>0) and (ID=StrToInt(copy(FileStrings.Strings[j], Pos('@@@',FileStrings.Strings[j])+3,10))) then
          begin
           SubItems.Add(copy(FileStrings.Strings[j],1,19));
           break;
          end;
        end;
      end;
    end
   else
    begin
     with ActivateListView.Items.Add do
      begin
       Caption:=copy(Str,Pos('===',Str)+3,Pos('+++',Str)-Pos('===',Str)-3);
       SubItems.Add(copy(Str,1,19));
      end;
    end;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 FileStrings.Free;
end;

end.
